Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaEmptyVisitor.java	(revision 9)
@@ -37,7 +37,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -50,7 +49,6 @@
 import org.momut.ooas.ast.identifiers.ConstantIdentifier;
 import org.momut.ooas.ast.identifiers.EnumIdentifier;
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.LocalVariableIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
@@ -71,7 +69,6 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.NondetBlock;
 import org.momut.ooas.ast.statements.PrioBlock;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.SeqBlock;
 import org.momut.ooas.ast.statements.SkipStatement;
 import org.momut.ooas.ast.types.AnyType;
@@ -86,7 +83,6 @@
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 
 public class OoaEmptyVisitor implements IAstVisitor {
@@ -102,8 +98,6 @@
 	@Override
 	public void visit(EnumIdentifier enumIdentifier)             {throw new UnsupportedOperationException();}
 	@Override
-	public void visit(LandmarkIdentifier landmarkIdentifier)     {throw new UnsupportedOperationException();}
-	@Override
 	public void visit(AttributeIdentifier attributeIdentifier)   {throw new UnsupportedOperationException();}
 	@Override
 	public void visit(ExpressionVariableIdentifier expressionVariableIdentifier) {throw new UnsupportedOperationException();}
@@ -152,8 +146,6 @@
 	@Override
 	public void visit(KillStatement killStatement)               {throw new UnsupportedOperationException();}
 	@Override
-	public void visit(QualitativeConstraintStatement qalitativeConstraintStatement) {throw new UnsupportedOperationException();}
-	@Override
 	public <T> void visit(ValueExpression<T> valueExpression)    {throw new UnsupportedOperationException();}
 	@Override
 	public void visit(UnresolvedIdentifierExpression unresolvedIdentifierExpression) {throw new UnsupportedOperationException();}
@@ -170,8 +162,6 @@
 	@Override
 	public void visit(ObjectConstructor objectConstructor)       {throw new UnsupportedOperationException();}
 	@Override
-	public void visit(QValConstructor qValConstructor)           {throw new UnsupportedOperationException();}
-	@Override
 	public void visit(AccessExpression accessExpression)         {throw new UnsupportedOperationException();}
 	@Override
 	public void visit(BinaryOperator binaryOperator)             {throw new UnsupportedOperationException();}
@@ -204,8 +194,6 @@
 	@Override
 	public void visit(MapType mapType)                           {throw new UnsupportedOperationException();}
 	@Override
-	public void visit(QrType qrType)                             {throw new UnsupportedOperationException();}
-	@Override
 	public void visit(TupleType tupleType)                       {throw new UnsupportedOperationException();}
 	@Override
 	public void visit(FunctionType functionType)                 {throw new UnsupportedOperationException();}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java	(revision 9)
@@ -47,11 +47,10 @@
 import org.momut.ooas.ast.statements.Call;
 import org.momut.ooas.ast.statements.GuardedCommand;
 import org.momut.ooas.ast.statements.KillStatement;
-import org.momut.ooas.ast.statements.QualitativeConstraintStatement;
 import org.momut.ooas.ast.statements.Statement;
 import org.momut.ooas.ast.types.FunctionType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserError;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.parser.ParserWarning;
@@ -186,7 +185,7 @@
 									RemoveWarning(exprvar, String.format("Free variable in expression: '%s'.", exprvar.tokenText()));
 									RemoveWarning(freeRhsVar, String.format("Free variable in expression: '%s'.", exprvar.tokenText()));
 								}
-								else if (UlyssesType.TypeEqual(freeRhsVar.type(), exprvar.type()))
+								else if (Type.TypeEqual(freeRhsVar.type(), exprvar.type()))
 								{
 									assignment.AddIdentifier(exprvar, null);
 									// remove free variable warnings
@@ -226,10 +225,10 @@
 			if (avalue.kind() != ExpressionKind.Call)
 				CheckMethodCallsArePure(avalue);
 
-			final UlyssesType acover = UlyssesType.CoverType(aplace.type(), avalue.type());
+			final Type acover = Type.CoverType(aplace.type(), avalue.type());
 			if (acover == null)
 				Error(assignment, String.format("Type mismatch in assignment: %s ( %s := %s )", aplace.toString(), aplace.type().toString(), avalue.type().toString()));
-			else if (!UlyssesType.TypeEqualByKind(aplace.type(), acover)) /*ignore range things.. (see warning below)*/
+			else if (!Type.TypeEqualByKind(aplace.type(), acover)) /*ignore range things.. (see warning below)*/
 				Error(assignment, String.format("Type mismatch in assignment: %s ( %s := %s )", aplace.toString(), aplace.type().toString(), acover.toString()));
 			else
 			{
@@ -239,7 +238,7 @@
 				if (uninitvars.size() > 0)
 					Error(assignment, String.format("Undefined variable '%s'", uninitvars.get(0).tokenText()));
 
-				if (!UlyssesType.TypeEqual(avalue.type(), acover))
+				if (!Type.TypeEqual(avalue.type(), acover))
 				{
 					final UnaryOperator cast = new UnaryOperator(ExpressionKind.Cast, avalue, avalue.line(), avalue.pos());
 					cast.SetType(acover);
@@ -250,7 +249,7 @@
 						throw new OoasCompilerRuntimeException();
 				}
 
-				if (UlyssesType.FirstTypeLessRange(aplace.type(), acover))
+				if (Type.FirstTypeLessRange(aplace.type(), acover))
 				{
 					if (constantvalue == null)
 					{
@@ -310,16 +309,6 @@
 	}
 
 
-	private void TypeCheckQualConstraint(QualitativeConstraintStatement qualConstr)
-	{
-		if (qualConstr.variable0().type().kind() != TypeKind.QrType && qualConstr.variable0().type().kind() != TypeKind.Any)
-			Error(qualConstr, String.format("Qualitative type expected: '%s'", qualConstr.variable0().tokenText()));
-		if (qualConstr.variable1().type().kind() != TypeKind.QrType && qualConstr.variable1().type().kind() != TypeKind.Any)
-			Error(qualConstr, String.format("Qualitative type expected: '%s'", qualConstr.variable0().tokenText()));
-		if (qualConstr.variable2() != null && qualConstr.variable2().type().kind() != TypeKind.QrType
-				&& qualConstr.variable2().type().kind() != TypeKind.Any)
-			Error(qualConstr, String.format("Qualitative type expected: '%s'", qualConstr.variable0().tokenText()));
-	}
 	private void TypeCheck(Statement statement)
 	{
 		switch (statement.kind())
@@ -357,10 +346,6 @@
 					&& callstatement.callExpression().kind() != ExpressionKind.foldLR)
 				Error(callstatement, "Not a valid method call");
 			break;
-		case QualConstraint:
-			final QualitativeConstraintStatement qualConstr = (QualitativeConstraintStatement)statement;
-			TypeCheckQualConstraint(qualConstr);
-			break;
 		default:
 			throw new NotImplementedException();
 		}
@@ -373,7 +358,7 @@
 		if (attributeIdentifier.initializer() == null)
 			throw new ArgumentException();
 
-		final UlyssesType atype = attributeIdentifier.initializer().type();
+		final Type atype = attributeIdentifier.initializer().type();
 		if (atype == null)
 			Error(attributeIdentifier, "Initializer lacks type.");
 		else
@@ -396,18 +381,18 @@
 								attributeIdentifier.initializer().freeVariables().symbolList().get(0).tokenText()));
 			else
 			{
-				final UlyssesType idtype = attributeIdentifier.type();
-				final UlyssesType acover = UlyssesType.CoverType(idtype, atype);
+				final Type idtype = attributeIdentifier.type();
+				final Type acover = Type.CoverType(idtype, atype);
 
 				if (acover == null)
 					Error(attributeIdentifier, String.format("Type mismatch in attribute initializer: %s ( %s := %s )", attributeIdentifier.toString(), idtype.toString(), atype.toString()));
-				else if (!UlyssesType.TypeEqualByKind(idtype, acover)) /*ignore range things.. (see warning below)*/
+				else if (!Type.TypeEqualByKind(idtype, acover)) /*ignore range things.. (see warning below)*/
 					Error(attributeIdentifier, String.format("Type mismatch in attribute initializer: %s ( %s := %s )", attributeIdentifier.toString(), idtype.toString(), acover.toString()));
 				else
 				{
 					final Expression constantvalue = attributeIdentifier.initializer().kind() == ExpressionKind.Value ? attributeIdentifier.initializer() : null;
 
-					if (!UlyssesType.TypeEqual(atype, acover))
+					if (!Type.TypeEqual(atype, acover))
 					{
 						final UnaryOperator cast = new UnaryOperator(ExpressionKind.Cast, attributeIdentifier.initializer(),
 								attributeIdentifier.initializer().line(), attributeIdentifier.initializer().pos());
@@ -415,7 +400,7 @@
 						attributeIdentifier.SetInitializer(cast);
 					}
 
-					if (UlyssesType.FirstTypeLessRange(idtype, acover))
+					if (Type.FirstTypeLessRange(idtype, acover))
 					{
 						if (constantvalue == null)
 						{
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaPrintVisitor.java	(revision 9)
@@ -39,7 +39,6 @@
 import org.momut.ooas.ast.expressions.ListConstructor;
 import org.momut.ooas.ast.expressions.MapConstructor;
 import org.momut.ooas.ast.expressions.ObjectConstructor;
-import org.momut.ooas.ast.expressions.QValConstructor;
 import org.momut.ooas.ast.expressions.SetConstructor;
 import org.momut.ooas.ast.expressions.TernaryOperator;
 import org.momut.ooas.ast.expressions.TupleConstructor;
@@ -54,7 +53,6 @@
 import org.momut.ooas.ast.identifiers.ExpressionVariableIdentifier;
 import org.momut.ooas.ast.identifiers.Identifier;
 import org.momut.ooas.ast.identifiers.IdentifierKind;
-import org.momut.ooas.ast.identifiers.LandmarkIdentifier;
 import org.momut.ooas.ast.identifiers.MainModule;
 import org.momut.ooas.ast.identifiers.MethodIdentifier;
 import org.momut.ooas.ast.identifiers.NamedActionIdentifier;
@@ -83,10 +81,9 @@
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
-import org.momut.ooas.ast.types.QrType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.codegen.OoasCodeEmitter;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
@@ -127,7 +124,7 @@
 	}
 
 	/*print the type identifier, or the type definition by calling the anAction delegate.*/
-	private void PrintType(UlyssesType atype, Action anAction)
+	private void PrintType(Type atype, Action anAction)
 	{
 		if (   (atype.identifier() != null)
 				&& (!atype.isAnonymousType())
@@ -306,24 +303,6 @@
 	}
 
 	@Override
-	public void visit(final QrType qrType)
-	{
-		PrintType(qrType, new Action(){
-			@Override
-			public void doIt() {
-				output.Append("qspace of [");
-				PrintEnumeration(qrType.landmarks());
-				output.Append("]");
-			}});
-	}
-
-	@Override
-	public void visit(LandmarkIdentifier landmarkIdentifier)
-	{
-		output.Append(landmarkIdentifier.tokenText());
-	}
-
-	@Override
 	public void visit(final OoActionSystemType ooActionSystemType)
 	{
 		PrintType(ooActionSystemType, new Action(){
@@ -768,22 +747,6 @@
 		output.Append("]");
 	}
 
-	@Override
-	public void visit(QValConstructor qValConstructor)
-	{
-		output.Append("qval(");
-		PrintSubElementOrNull(qValConstructor.value()[0]);
-		if (qValConstructor.value().length == 2)
-		{
-			output.Append(" .. ");
-			PrintSubElementOrNull(qValConstructor.value()[1]);
-		}
-		output.Append(",");
-		output.Append(qValConstructor.valueDeriv().toString());
-		output.Append(")");
-	}
-
-
 	private boolean make_parens = false;
 
 	@Override
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaReplaceOpaqueVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaReplaceOpaqueVisitor.java	(revision 8)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaReplaceOpaqueVisitor.java	(revision 9)
@@ -43,7 +43,7 @@
 import org.momut.ooas.ast.types.OpaqueType;
 import org.momut.ooas.ast.types.TupleType;
 import org.momut.ooas.ast.types.TypeKind;
-import org.momut.ooas.ast.types.UlyssesType;
+import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserState;
 import org.momut.ooas.utils.exceptions.NotImplementedException;
 
@@ -61,7 +61,7 @@
 		switch (parent.nodeType())
 		{
 		case type:
-			ReplaceOpaqueInType((UlyssesType)parent);
+			ReplaceOpaqueInType((Type)parent);
 			break;
 		case identifier:
 			ReplaceOpaqueInIdentifier((Identifier)parent);
@@ -122,7 +122,7 @@
 		}
 	}
 
-	private void ReplaceOpaqueInType(UlyssesType ulyssesType)
+	private void ReplaceOpaqueInType(Type ulyssesType)
 	{
 		switch (ulyssesType.kind())
 		{
@@ -133,7 +133,7 @@
 
 			for (int cntr = 0; cntr < func.parameter().size(); cntr ++)
 			{
-				UlyssesType t = func.parameter().get(cntr);
+				Type t = func.parameter().get(cntr);
 				if (t.kind() == TypeKind.OpaqueType)
 					func.parameter().set(cntr, ((OpaqueType)t).resolvedType());
 			}
@@ -156,7 +156,7 @@
 			case TupleType:
 				TupleType aTuple = (TupleType)ulyssesType;
 				for (int cntr = 0; cntr < aTuple.innerTypes().size(); cntr ++) {
-					UlyssesType t = aTuple.innerTypes().get(cntr);
+					Type t = aTuple.innerTypes().get(cntr);
 					if (t.kind() == TypeKind.OpaqueType)
 						aTuple.innerTypes().set(cntr, ((OpaqueType)t).resolvedType());
 				}
@@ -175,7 +175,7 @@
           to replace.*/
 		if ((subElement != null)
 				&& (subElement.nodeType() == AstNodeTypeEnum.type)
-				&& (((UlyssesType)subElement).kind() == TypeKind.OpaqueType))
+				&& (((Type)subElement).kind() == TypeKind.OpaqueType))
 			ReplaceOpaque(parent);
 	}
 
